#include "Strategy_BuildTaskManager.h"

using namespace MyBot;


void StrategyManager::updateScoutTask()
{
	if (BWAPI::Broodwar->getFrameCount() % 6 != 0) {
		return;
	}

	BWAPI::Unit targetEnemyUnit = nullptr;
	BWAPI::Position targetEnemyUnitPosition = BWAPI::Positions::None;

	if (BWAPI::Broodwar->self()->getRace() == BWAPI::Races::Zerg) {

		//     Ÿũ
		if (true) {

			//    ,  ۸ ݿ Ͽ 9°  
			if (InformationManager::Instance().enemyRace == BWAPI::Races::Unknown) {
				workerScoutCondition_completedWorkerCount = 9;
				isToScoutWithWorker = true;

				// Ÿũ ߰ :   ľ. ߿ 佺 / ׶ ̶  ˷, ϲ ׳ ƿ͵ ȴ
				insertTask(StrategicTask(TaskGoalType::Figure_Out_Enemy_Race));
			}
			//    ,  ۸ ݿ Ͽ 9 Ǯ  
			else if (InformationManager::Instance().enemyRace == BWAPI::Races::Zerg) {
				isToScoutWithWorker = false;
				cancelScoutDroneSquad();
			}
			//   佺, ׶̸,  ε峪 ۸θ 
			else if (InformationManager::Instance().enemyRace == BWAPI::Races::Protoss || InformationManager::Instance().enemyRace == BWAPI::Races::Terran) {
				isToScoutWithWorker = false;
				cancelScoutDroneSquad();
			}
		}

		//  Ȳ  Ʊ Ȳ   Ÿũ
		if (true) {

			//   𸣴 Ȳ
			if (enemyMainBaseLocation == nullptr) {
				// Ÿũ ߰ :   ġ ľ
				insertTask(StrategicTask(TaskGoalType::Figure_Out_Enemy_BaseLocation));
			}

			if (enemyMainBaseLocation != nullptr) {

				//   Ȱðų,  2 ̻  Ȳ
				if (baseLocationStatusMap[enemyMainBaseLocation].lastVisibleTime < 0
					|| BWAPI::Broodwar->getFrameCount() - baseLocationStatusMap[enemyMainBaseLocation].lastVisibleTime >= 20 * 60 * 2) {
					insertTask(StrategicTask(TaskGoalType::Scout_Enemy_MainBaseLocation));
				}

				//   ѹ  ߰, ǹ ϳ Ե ,    ѷ  ٸ ̽ ѷ
				if (BWAPI::Broodwar->isExplored(enemyMainBaseLocation->getTilePosition())
					&& InformationManager::Instance().existsPlayerBuildingInRegion(BWTA::getRegion(enemyMainBaseLocation->getTilePosition()), enemyPlayer))
				{
					// TODO :   ѷ
					insertTask(StrategicTask(TaskGoalType::Scout_Enemy_MainBaseLocation));
				}
			}

			//  ո Ȱðų,  2 ̻  Ȳ 
			if (enemyFirstExpansionBaseLocation != nullptr) {
				if (baseLocationStatusMap[enemyFirstExpansionBaseLocation].lastVisibleTime < 0
					|| BWAPI::Broodwar->getFrameCount() - baseLocationStatusMap[enemyFirstExpansionBaseLocation].lastVisibleTime >= 20 * 60 * 2) {
					insertTask(StrategicTask(TaskGoalType::Scout_Enemy_First_Expansion));
				}
			}

			//  ù°  Ȱðų,  2 ̻  Ȳ 
			/*
			if (enemyMainBaseLocation != nullptr) {
				if (chokepointStatusMap[enemyFirstChokepoint].lastVisibleTime < 0
					|| BWAPI::Broodwar->getFrameCount() - chokepointStatusMap[enemyFirstChokepoint].lastVisibleTime >= 20 * 60 * 2) {
					insertTask(StrategicTask(TaskGoalType::Scout_Enemy_Chokepoint));
				}
			}
			*/

			//  Ƽ ,  2 ̻  ̽ ִ Ȳ 
			if (InformationManager::Instance().getOccupiedBaseLocations(InformationManager::Instance().enemyPlayer).size() > 1) {
				for (BWTA::BaseLocation * baseLocation : BWTA::getBaseLocations()) {
					if (baseLocationStatusMap[baseLocation].locationStatus == LocationStatus::Enemy_Occupied) {
						if (baseLocationStatusMap[baseLocation].lastVisibleTime < 0
							|| BWAPI::Broodwar->getFrameCount() - baseLocationStatusMap[baseLocation].lastVisibleTime >= 20 * 60 * 2) {
							insertTask(StrategicTask(TaskGoalType::Scout_Enemy_Other_Expansion, BWAPI::UnitTypes::None, BWAPI::TechTypes::None, BWAPI::UpgradeTypes::None, nullptr,
								baseLocation->getPosition(), 1));
						}
					}
				}
			}

			// Ȱ ̽ ְų,  2 ̻  ̽ ִ Ȳ 
			if (enemyMainBaseLocation != nullptr) {
				bool isThereInvisibleBase = false;
				for (BWTA::BaseLocation * baseLocation : BWTA::getBaseLocations()) {
					if (baseLocationStatusMap[baseLocation].lastVisibleTime < 0
						|| BWAPI::Broodwar->getFrameCount() - baseLocationStatusMap[baseLocation].lastVisibleTime >= 20 * 60 * 2) {
						insertTask(StrategicTask(TaskGoalType::Scout_Empty_BaseLocations));
						break;
					}
				}
			}

			// ε尡 ƴٴҼ    Ȳ Ǹ,  ʰ θ ٴѴ
			if (isEnemyHasDangerousUnitToOverlord == false) {
				if (getEnemyHasDangerousUnitToOverlord() == true) {
					std::cout << "isEnemyHasDangerousUnitToOverlord = true -> moveToSafePosition " << std::endl;
					isEnemyHasDangerousUnitToOverlord = true;
				}
			}

			// ε尡 ƴٴϱ⿡ ſ  Ȳ Ǹ,    ʴ´
			if (isToScoutWithOverlord == true) {
				if (isVeryDangerousToEveryOverlord())
				{
					isToScoutWithOverlord = false;
					std::cout << "isVeryDangerousToEveryOverlord = true -> cancelScoutOverlordSquad" << std::endl;
					cancelScoutOverlordSquad();
				}
			}

			// ϲ ƴٴϱ⿡ ſ  Ȳ Ǹ,    ʴ´
			if (isToScoutWithWorker == true) {
				if (isVeryDangerousToScoutWithDrone())
				{
					std::cout << "isVeryDangerousToScoutWithDrone = true -> cancelScoutDroneSquad " << std::endl;
					isToScoutWithWorker = false;
					cancelScoutDroneSquad();
				}
			}

			// TODO : ۸  Ϸ 񷯺

			// TODO : ϲ   ִ  ǥ  ޼Ǿ,   ʴ´
			// ϲ ,      Ȯ,
			//     ʹ   Ȯο Ѵ
		}


		// Ʊ    Ÿũ
		if (true) {
			// Ʊ  4 ۸ ̸,   𸣰ų  , ϲ  ʴ´
			if (myCurrentCombatStrategy == Zerg_Combat_4Drone_Zergling_Rush) {
				workerScoutCondition_completedWorkerCount = -1;
				isToScoutWithWorker = false;
			}

			// Ŀ    ó Ƽ  /  ϳ Ƶα
			if (isToBurrowOnEmptyBaseLocation) {

				if (BWAPI::Broodwar->self()->completedUnitCount(BWAPI::UnitTypes::Zerg_Lurker) >= 5) {

					// Eliminate Ű 尡 ƴ 쿡
					if (StrategyManager::Instance().taskList.find(StrategicTask(Eliminate_Enemy_Player)) == StrategyManager::Instance().taskList.end()) {
						insertTask(StrategicTask(TaskGoalType::Burrow_On_Empty_BaseLocation, BWAPI::UnitTypes::None, BWAPI::TechTypes::None, BWAPI::UpgradeTypes::None, nullptr, BWAPI::Positions::None, 0));
					}
				}
			}

			/*
			// Ա   ǹ   ο ۸ غ ҿ
			// Ŀǵ   ļ  Addon ǹ   ο  : غ,   
			for (auto & it : InformationManager::Instance().getUnitAndUnitInfoMap(InformationManager::Instance().enemyPlayer)) {
			BWAPI::Unit enemyUnit = it.first;
			UnitInfo & enemyUnitInfo = it.second;

			if (enemyUnitInfo.type.canBuildAddon()) {
			if (enemyUnit->getAddon() == nullptr)
			{
			// Addon ǹ  ġ  ǹ ϴ
			// Addon ǹ 2 * 2 Ÿ 
			BWAPI::TilePosition targetTilePosition = enemyUnit->getTilePosition();
			targetTilePosition.x += enemyUnitInfo.type.tileWidth()+1;
			targetTilePosition.y += 1+1;

			BWAPI::Position targetPosition(targetTilePosition.x * TILE_SIZE, targetTilePosition.y * TILE_SIZE);

			insertTask(StrategicTask(TaskGoalType::Burrow_On_Empty_BaseLocation, BWAPI::UnitTypes::None, BWAPI::TechTypes::None, BWAPI::UpgradeTypes::None, nullptr,
			targetPosition, 0));
			}

			}
			*/

		}

		//     Ÿũ

	}

}
