#include "Strategy_CombatTaskManager.h"

using namespace MyBot;

Strategy_CombatTaskManager & Strategy_CombatTaskManager::Instance()
{
	static Strategy_CombatTaskManager instance;

	return instance;
}

void Strategy_CombatTaskManager::update()
{
	// 1ʿ 6 
	//if (BWAPI::Broodwar->getFrameCount() % 4 != 0) {
	//	return;
	//}

	bool isToFindError = false;

	if (isToFindError) std::cout << "<a";

	updateUnitCount();

	int mutaliskCount = 0;
	mainCombatMutaliskSquadCenterPosition.x = 0;
	mainCombatMutaliskSquadCenterPosition.y = 0;
	for (auto & unit : StrategyManager::Instance().mainCombatMutaliskSquad.unitset) {
		if (unit->canAttack()) {
			mainCombatMutaliskSquadCenterPosition.x += unit->getPosition().x;
			mainCombatMutaliskSquadCenterPosition.y += unit->getPosition().y;
			mutaliskCount++;
		}
	}
	if (mutaliskCount > 0) {
		mainCombatMutaliskSquadCenterPosition.x /= mutaliskCount;
		mainCombatMutaliskSquadCenterPosition.y /= mutaliskCount;
	}

	for (auto it = attackerTargetMap.begin(); it != attackerTargetMap.end();) {

		BWAPI::Unit attacker = it->first;
		BWAPI::Unit targetUnit = it->second;

		if (attacker == nullptr || attacker->exists() == false || attacker->getHitPoints() <= 0
			|| targetUnit == nullptr || targetUnit->exists() == false || targetUnit->getHitPoints() <= 0)
		{
			//std::cout << " eraseTask " << StrategicTaskUtil::getTaskGoalTypeString(targetTask.taskGoal).c_str() << std::endl;
			it = attackerTargetMap.erase(it);
			return;
		}
		else {
			++it;
		}
	}
	
	if (isToFindError) std::cout << "b";

	// mainBaseDefenseSquad    ó  ְ Ѵ
	if (StrategyManager::Instance().mainBaseDefenseSquad.unitset.size() >= 1) {

		for (auto & unit : StrategyManager::Instance().mainBaseDefenseSquad.unitset) {
			Mission* unitMission = StrategyManager::Instance().mainBaseDefenseSquad.getUnitMission(unit);
			if (unitMission->missionType == MissionType::Mission_Undefined)
			{
				// ո Ծ ո翡
				if (InformationManager::Instance().getOccupiedBaseLocations(InformationManager::Instance().selfPlayer).size() == 2) 
				{
					StrategyManager::Instance().mainBaseDefenseSquad.setUnitMission(unit, Mission(MissionType::AttackMove, StrategyManager::Instance().myFirstExpansionBaseLocation->getPosition()));
				}
				// ո ȸԾų, 3̻ Ծ   ְ Ѵ
				else {
					double minDistance = 100000000;
					double tempDistance = 0;
					BWAPI::Position targetPosition;
					for (BWTA::BaseLocation * baseLocation : InformationManager::Instance().getOccupiedBaseLocations(InformationManager::Instance().selfPlayer)) {
						tempDistance = unit->getDistance(baseLocation->getPosition());
						if (minDistance > tempDistance) {
							minDistance = tempDistance;
							targetPosition = baseLocation->getPosition();
							StrategyManager::Instance().mainBaseDefenseSquad.setUnitMission(unit, Mission(MissionType::AttackMove, targetPosition));
						}
					}
				}
			}
		}
	}
	if (isToFindError) std::cout << "c";

	//  켱  
	if (StrategyManager::Instance().taskList.find(StrategicTask(Attack_Enemy_Worker_In_Main_Region)) != StrategyManager::Instance().taskList.end())
	{
		attackEnemyWorkerUnitInMainRegion();
	}

	if (isToFindError) std::cout << "d";
	if (StrategyManager::Instance().taskList.find(StrategicTask(Attack_Enemy_Dangerous_Building_In_Main_Region)) != StrategyManager::Instance().taskList.end())
	{
		attackEnemyBuildingUnitInMainRegion();
	}
	if (isToFindError) std::cout << "e";

	if (StrategyManager::Instance().taskList.find(StrategicTask(Attack_Enemy_Ground_Unit_In_Our_Region)) != StrategyManager::Instance().taskList.end())
	{
		attackEnemyGroundUnitInOurRegion();
	}
	if (isToFindError) std::cout << "f";

	if (StrategyManager::Instance().taskList.find(StrategicTask(Block_And_Hold_On_ChokePoint)) != StrategyManager::Instance().taskList.end())
	{
		blockAndHoldOnChokePoint();
	}
	if (isToFindError) std::cout << "g";

	// ź Ŀδ ź
	if (StrategyManager::Instance().taskList.find(StrategicTask(Burrow_And_Ambush_Attack_With_Lurker)) != StrategyManager::Instance().taskList.end())
	{
		burrowAndAmbushAttackWithLurker();
	}
	if (isToFindError) std::cout << "i0";

	//   
	if (StrategyManager::Instance().taskList.find(StrategicTask(Attack_Enemy_BaseLocation_With_Early_Zergling_Unit)) != StrategyManager::Instance().taskList.end())
	{
		attackEnemyWithEarlyZerglingSquad();
	}
	if (isToFindError) std::cout << "i1";

	//   
	if (StrategyManager::Instance().taskList.find(StrategicTask(Attack_Enemy_BaseLocation_With_Ground_Unit)) != StrategyManager::Instance().taskList.end())
	{
		attackEnemyWithMainCombatGroundSquad();	
	}
	if (isToFindError) std::cout << "i2";

	// Ż  
	if (StrategyManager::Instance().taskList.find(StrategicTask(Attack_Enemy_BaseLocation_With_Mutalisk)) != StrategyManager::Instance().taskList.end())
	{
		attackEnemyWithMainCombatMutaliskSquad();
	}
	if (isToFindError) std::cout << "i3";

	// Ŀ 
	if (StrategyManager::Instance().taskList.find(StrategicTask(Attack_With_Lurker_Drop)) != StrategyManager::Instance().taskList.end())
	{
		attackWithLurkerDrop();
	}
	if (isToFindError) std::cout << "h";

	// ̳Ʈ Ű
	if (StrategyManager::Instance().taskList.find(StrategicTask(Eliminate_Enemy_Player)) != StrategyManager::Instance().taskList.end())
	{
		executeEnemyElimination();
	}
	if (isToFindError) std::cout << "j";


	// ӹ  Ǿִ / ӹ  ϲ Ʈ
	//  ϲ Ѿ ʹ ָ Ȱ Ѵ
	/*
	if (StrategyManager::Instance().reservedSquad.unitset.size() > 0) {

		Squad* currentSquad = &StrategyManager::Instance().reservedSquad;

		for (auto & unit : currentSquad->unitset) {

			if (unit->getType() == BWAPI::UnitTypes::Zerg_Drone) {
				
				bool isTooFarFromBaseLocation = true;
				for (auto baselocation : InformationManager::Instance().getOccupiedBaseLocations(InformationManager::Instance().selfPlayer)) {
					if (unit->getDistance(baselocation->getPosition()) < 50 * TILE_SIZE) {
						isTooFarFromBaseLocation = false;
						break;
					}
				}
				
				if (isTooFarFromBaseLocation) {
					WorkerManager::Instance().setIdleWorker(unit);
				}
			}
		}
	}
	*/


	/*
	// mainCombatMutaliskSquad  ϸ
	if (StrategyManager::Instance().mainCombatMutaliskSquad.unitset.size() >= 1) {

		// ⺻ mainCombatMutaliskSquad ü ʶ ĳ´
		for (auto & unit : StrategyManager::Instance().mainCombatMutaliskSquad.unitset) {

			// TODO :   ó ٴ Ѱ ĳ ͵ 
			Mission* unitMission = StrategyManager::Instance().mainCombatMutaliskSquad.getUnitMission(unit);
			if (unit->getDistance(mainCombatMutaliskSquadCenterPosition) > 1 * TILE_SIZE)
			{
				StrategyManager::Instance().mainCombatMutaliskSquad.setUnitMission(unit,
					Mission(MissionType::MovePoint, mainCombatMutaliskSquadCenterPosition));
			}
		}
	}
	*/

	// mainCombatMutaliskSquad  ϸ
	if (StrategyManager::Instance().mainCombatMutaliskSquad.unitset.size() >= 1) {

		// reinforceMainCombatMutaliskSquad ڰ ʹ  mainCombatMutaliskSquad  move Ű⺸ ü ġ Ѵ?
		//if (StrategyManager::Instance().reinforceMainCombatMutaliskSquad.unitset.size() <= 3) {
		//	for (auto & unit : StrategyManager::Instance().reinforceMainCombatMutaliskSquad.unitset) {
		//		StrategyManager::Instance().reinforceMainCombatMutaliskSquad.setUnitMission(unit,
		//			Mission(MissionType::MovePoint, StrategyManager::Instance().reinforceMainCombatMutaliskSquad.unitset.getPosition()));
		//	}
		//}
		// reinforceMainCombatMutaliskSquad  mainCombatMutaliskSquad  move  շŲ
		//  : mainCombatMutaliskSquad  ָ , reinforceMainCombatMutaliskSquad  mainCombatMutaliskSquad  շϴ°  ֿ켱 ǥ ǰ,
		// շϱ  , Ƽ , ƹ͵ Ѵ
		//else 
		{
			for (auto & unit : StrategyManager::Instance().reinforceMainCombatMutaliskSquad.unitset) {
				StrategyManager::Instance().reinforceMainCombatMutaliskSquad.setUnitMission(unit,
					Mission(MissionType::MovePoint, mainCombatMutaliskSquadCenterPosition));
			}
		}
	}


	//  
	StrategyManager::Instance().mainCombatZerglingSquad.executeMission();		///<   ۸ δ :  / ո 
	StrategyManager::Instance().mainCombatHydraliskSquad.executeMission();		///<    δ :  / ո 
	StrategyManager::Instance().mainCombatLurkerSquad.executeMission();		///<   Ŀ δ :  / ո 
	StrategyManager::Instance().mainCombatMutaliskSquad.executeMission();		///<   Ż/ٿ/ δ :  / ո 
	StrategyManager::Instance().mainCombatScourgeSquad.executeMission();		///<   Ŀ δ :  / ո 
	StrategyManager::Instance().mainCombatOverlordSquad.executeMission();		///<   ε δ : ε
	StrategyManager::Instance().mainCombatQueenSquad.executeMission();			///<    δ : 
	StrategyManager::Instance().mainCombatDefilerSquad.executeMission();		///<   Ϸ δ : Ϸ, ̿ ۸,  ε
	StrategyManager::Instance().mainCombatUltraliskSquad.executeMission();		///<   Ʈ δ :  / ո 

	StrategyManager::Instance().reinforceMainCombatMutaliskSquad.executeMission();		///<   Ż  δ

	StrategyManager::Instance().subCombatSquad.executeMission();				///<   δ : Ƽ 
	StrategyManager::Instance().subCombatOverlordSquad.executeMission();		///<    δ : ε. 

	StrategyManager::Instance().subCombatReinforceSquad.executeMission();		///<   δ

	StrategyManager::Instance().dropAttackSquad.executeMission();				///< δ : , Ŀ.  ε
	StrategyManager::Instance().ambushCombatLurkerSquad.executeMission();		///< źδ : Ŀ.  ε
	StrategyManager::Instance().multiObstructLurkerSquad.executeMission();		///< źδ : Ŀ.  ε
	if (isToFindError) std::cout << "k";

	StrategyManager::Instance().mainBaseDefenseSquad.executeMission();			///< ַ  δ : ۸, , Ŀ, Ż

	StrategyManager::Instance().mainBaseClearSquad1.executeMission();			///<      ްϴ δ : ۸, ϲ 
	StrategyManager::Instance().mainBaseClearSquad2.executeMission();			///<    Ŀ  ްϴ δ : ۸, ϲ 
	StrategyManager::Instance().mainChokepointBlockingSquad.executeMission();
	StrategyManager::Instance().mainBasePatrolSquad.executeMission();			///<  ֺ Ʈ δ : ۸, Ŀ, ε

	StrategyManager::Instance().firstExpansionDefenseSquad.executeMission();	///< ո  δ : , Ż
	StrategyManager::Instance().firstExpansionPatrolSquad.executeMission();	///< ո ֺ Ʈ δ : ۸, Ŀ, ε

	StrategyManager::Instance().secondExpansionDefenseSquad.executeMission();	///< Ƽ  δ : , Ż
	StrategyManager::Instance().secondExpansionPatrolSquad.executeMission();	///< Ƽ ֺ Ʈ δ : ۸, Ŀ, ε
	if (isToFindError) std::cout << "l";

	/*
	if (getMainCombatUnitCount() <= 4) {
	insertTask(StrategicTask(TaskGoalType::Block_And_Hold_On_ChokePoint, BWAPI::UnitTypes::None, BWAPI::TechTypes::None, BWAPI::UpgradeTypes::None, nullptr,
	InformationManager::Instance().getSecondChokePoint(InformationManager::Instance().selfPlayer)->getCenter(), 0));
	}
	*/
}

void Strategy_CombatTaskManager::attackEnemyWorkerUnitInMainRegion()
{
	Squad* mySquad = &StrategyManager::Instance().mainBaseClearSquad1;

	// HitPoint    öŲ
	BWAPI::Unit unitToRemove = nullptr;
	for (auto & unit : mySquad->unitset) {
		if (unit->getHitPoints() < unit->getType().maxHitPoints() * 0.3) {
			unitToRemove = unit;
			break;
		}
	}
	if (unitToRemove != nullptr) {
		CommandUtil::move(unitToRemove, StrategyManager::Instance().myMainBaseLocation->getPosition());
		StrategyManager::Instance().moveUnitBetweenSquad(mySquad, &StrategyManager::Instance().reservedSquad, unitToRemove->getType(), 1, unitToRemove);
	}


	for (auto & unit : mySquad->unitset) {

		bool isIdleUnit = true;

		for (auto & iterator : mySquad->unitTargetMap) {
			if (iterator.first == unit) {
				isIdleUnit = false;
				break;
			}
		}

		// Ʊ ֿ Ÿ ȵǾ Ѵ
		if (isIdleUnit) {

			//   ϲ 
			for (auto & enemyUnit : BWAPI::Broodwar->enemy()->getUnits()) {

				if (enemyUnit != nullptr && enemyUnit->exists() && enemyUnit->getHitPoints() > 0 && enemyUnit->getType().isWorker()) {

					if (BWTA::getRegion(enemyUnit->getPosition()) == StrategyManager::Instance().myMainBaseLocation->getRegion()
						|| BWTA::getRegion(enemyUnit->getPosition()) == StrategyManager::Instance().myFirstExpansionBaseLocation->getRegion())
					{
						mySquad->unitTargetMap[unit] = enemyUnit;
						mySquad->setUnitMission(unit, Mission(MissionType::AttackMove, enemyUnit->getPosition()));
						break;
					}
				}
			}
		}
		// Ʊ ֿ Ÿ Ǿ Ѵ
		// TODO :   ϲ Ӿ ġ ,  Ƽ ׿ Ѵ
		else {
			BWAPI::Unit enemyUnit = mySquad->unitTargetMap[unit];
			if (enemyUnit != nullptr ) {

				//   ϲ þ  ϸ
				if (enemyUnit->exists()) {
					mySquad->setUnitMission(unit, Mission(MissionType::Attack, enemyUnit));
				}
				//   ϲ þ  
				else {
					for (auto & it : InformationManager::Instance().getUnitAndUnitInfoMap(InformationManager::Instance().enemyPlayer)) {
						BWAPI::Unit enemyUnit = it.first;
						UnitInfo & enemyUnitInfo = it.second;

						mySquad->setUnitMission(unit, Mission(MissionType::AttackMove, enemyUnitInfo.lastPosition));
					}
				}
			}

		}
	}
}

void Strategy_CombatTaskManager::attackEnemyBuildingUnitInMainRegion()
{
	Squad* mySquad = &StrategyManager::Instance().mainBaseClearSquad2;

	// HitPoint    öŲ
	BWAPI::Unit unitToRemove = nullptr;
	for (auto & unit : mySquad->unitset) {
		if (unit->getHitPoints() < unit->getType().maxHitPoints() * 0.3) {
			unitToRemove = unit;
			break;
		}
	}
	if (unitToRemove != nullptr) {
		CommandUtil::move(unitToRemove, StrategyManager::Instance().myMainBaseLocation->getPosition());
		StrategyManager::Instance().moveUnitBetweenSquad(mySquad, &StrategyManager::Instance().reservedSquad, unitToRemove->getType(), 1, unitToRemove);
	}


	BWAPI::Unit targetEnemyWorker = nullptr;
	BWAPI::Unit targetEnemyMarine = nullptr;
	BWAPI::Unit targetEnemyBuildingToAttackFirst = nullptr;
	BWAPI::Unit targetEnemyBuildingToAttackSecond = nullptr;
	int enemyBuildingCount = 0;

	for (auto & it : InformationManager::Instance().getUnitAndUnitInfoMap(InformationManager::Instance().enemyPlayer)) {
		BWAPI::Unit enemyUnit = it.first;
		UnitInfo & enemyUnitInfo = it.second;

		if (BWTA::getRegion(enemyUnitInfo.lastPosition) == StrategyManager::Instance().myMainBaseLocation->getRegion()
			|| BWTA::getRegion(enemyUnitInfo.lastPosition) == StrategyManager::Instance().myFirstExpansionBaseLocation->getRegion())
		{
			if (enemyUnitInfo.lastHealth > 0 && enemyUnitInfo.isLastPositionValid == true && enemyUnit != nullptr && enemyUnit->exists()) {

				if (enemyUnitInfo.type.isWorker()) {
					targetEnemyWorker = enemyUnit;
				}
				else if (enemyUnitInfo.type == BWAPI::UnitTypes::Terran_Marine) {
					targetEnemyMarine = enemyUnit;
				}
				else if (enemyUnitInfo.type.isBuilding()) {
					if (enemyUnitInfo.type == BWAPI::UnitTypes::Terran_Bunker
						|| enemyUnitInfo.type == BWAPI::UnitTypes::Protoss_Pylon
						|| enemyUnitInfo.type == BWAPI::UnitTypes::Zerg_Creep_Colony
						|| enemyUnitInfo.type == BWAPI::UnitTypes::Zerg_Nydus_Canal)
					{
						targetEnemyBuildingToAttackFirst = enemyUnit;
						enemyBuildingCount++;
					}
					else if (enemyUnitInfo.type == BWAPI::UnitTypes::Protoss_Photon_Cannon
						|| enemyUnitInfo.type == BWAPI::UnitTypes::Zerg_Sunken_Colony
						|| enemyUnitInfo.type == BWAPI::UnitTypes::Terran_Refinery
						|| enemyUnitInfo.type == BWAPI::UnitTypes::Protoss_Assimilator
						|| enemyUnitInfo.type == BWAPI::UnitTypes::Zerg_Extractor)
					{
						targetEnemyBuildingToAttackSecond = enemyUnit;
						enemyBuildingCount++;
					}
				}				
			}
		}
	}

	for (auto & unit : mySquad->unitset) {
		Mission* unitMission = mySquad->getUnitMission(unit);

		if (targetEnemyBuildingToAttackFirst != nullptr) {

			// targetEnemyBuildingToAttackFirst   Ǽ  
			if (targetEnemyBuildingToAttackFirst->isCompleted() == false) {

				// ׶̸ Ǽ ϲ  ̰,   δ
				if (targetEnemyBuildingToAttackFirst->getType().getRace() == BWAPI::Races::Terran) {
					if (targetEnemyWorker != nullptr && targetEnemyWorker->exists()) {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyWorker));
					}
					else if (targetEnemyMarine != nullptr && targetEnemyMarine->exists()) {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyMarine));
					}
					else {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyBuildingToAttackFirst));
					}
				}
				// 佺
				else if (targetEnemyBuildingToAttackFirst->getType().getRace() == BWAPI::Races::Protoss) {

					if (targetEnemyWorker != nullptr && targetEnemyWorker->exists() && unit->getDistance(targetEnemyWorker->getPosition()) < 1 * TILE_SIZE) {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyWorker));
					}
					else {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyBuildingToAttackFirst));
					}
				}
				// 
				else {
					mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyBuildingToAttackFirst));
				}
			}
			// targetEnemyBuildingToAttackFirst  Ǽ Ϸ Ǿ
			else {
				// ׶̸ Ǽ ϲ  ̰,   δ
				if (targetEnemyBuildingToAttackFirst->getType().getRace() == BWAPI::Races::Terran) {
					if (targetEnemyWorker != nullptr && targetEnemyWorker->exists()) {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyWorker));
					}
					else if (targetEnemyMarine != nullptr && targetEnemyMarine->exists()) {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyMarine));
					}
					else {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyBuildingToAttackFirst));
					}
				}
				// 佺
				else if (targetEnemyBuildingToAttackFirst->getType().getRace() == BWAPI::Races::Protoss) {

					if (targetEnemyWorker != nullptr && targetEnemyWorker->exists() && unit->getDistance(targetEnemyWorker->getPosition()) < 1 * TILE_SIZE) {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyWorker));
					}
					else if (targetEnemyBuildingToAttackSecond != nullptr && targetEnemyBuildingToAttackSecond->exists()) {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyBuildingToAttackSecond));
					}
					else {
						mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyBuildingToAttackFirst));
					}
				}
				// 
				else {
					mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyBuildingToAttackFirst));
				}
			}
		}
		else if (targetEnemyBuildingToAttackSecond != nullptr) {

			// ׶̸ Ǽ ϲ  δ
			if (targetEnemyBuildingToAttackSecond->getType().getRace() == BWAPI::Races::Terran) {
				if (targetEnemyWorker != nullptr && targetEnemyWorker->exists()) {
					mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyWorker));
				}
				else {
					mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyBuildingToAttackSecond));
				}
			}
			// 佺
			else if (targetEnemyBuildingToAttackSecond->getType().getRace() == BWAPI::Races::Protoss) {

				if (targetEnemyWorker != nullptr && targetEnemyWorker->exists() && unit->getDistance(targetEnemyWorker->getPosition()) < 1 * TILE_SIZE) {
					mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyWorker));
				}
				else {
					mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyBuildingToAttackSecond));
				}
			}
			// 
			else {
				mySquad->setUnitMission(unit, Mission(MissionType::Attack, targetEnemyBuildingToAttackSecond));
			}
		}
	}
}

void Strategy_CombatTaskManager::attackEnemyGroundUnitInOurRegion()
{
	Mission* unitMission;
	Squad* mySquad = &StrategyManager::Instance().mainBaseDefenseSquad;

	if (mySquad->unitset.size() > 0) {

		int nonWorkerCountAroundMainBase = 0;
		for (auto & unit : mySquad->unitset) {

			if (unit == nullptr) {
				std::cout << "my unit is dead1" << std::endl;
				continue;
			}

			// Ʊ      īƮ
			if (unit->getType().isWorker() == false 
				&& unit->getDistance(StrategyManager::Instance().myMainBaseLocation->getPosition()) < 5 * TILE_SIZE) {
				nonWorkerCountAroundMainBase++;
			}
		}
		

		for (auto & unit : mySquad->unitset) {

			if (unit == nullptr) {
				std::cout << "my unit is dead2" << std::endl;
				continue;
			}

			unitMission = mySquad->getUnitMission(unit);

			for (auto & it : InformationManager::Instance().getUnitAndUnitInfoMap(InformationManager::Instance().enemyPlayer)) {
				BWAPI::Unit enemyUnit = it.first;
				UnitInfo & enemyUnitInfo = it.second;

				if (enemyUnit == nullptr) {
					std::cout << "enemyUnit is null1" << std::endl;
					continue;
				}

				// , ո Ӹ ƴ϶ ü    
				for (BWTA::BaseLocation* myBaseLocationToDefense : InformationManager::Instance().getOccupiedBaseLocations(InformationManager::Instance().selfPlayer)) {
					if (myBaseLocationToDefense->getPosition().getDistance(enemyUnitInfo.lastPosition) < 8 * TILE_SIZE) {
					
						int mySunkenCount = 0;
						int mySunkenIsAttacked = false;

						// TODO : filter
						for (auto & sunken : BWAPI::Broodwar->getUnitsInRadius(myBaseLocationToDefense->getPosition(), 8 * TILE_SIZE)) {
						
							if (sunken == nullptr) {
								std::cout << "sunken is null1" << std::endl;
								continue;
							}

							if (sunken->getPlayer() == InformationManager::Instance().selfPlayer
								&& (sunken->getType() == BWAPI::UnitTypes::Zerg_Sunken_Colony
									|| sunken->getType() == BWAPI::UnitTypes::Zerg_Creep_Colony)) 
							{
								mySunkenCount++;
								if (sunken->isCompleted() ) {
									if (sunken->getHitPoints() < sunken->getType().maxHitPoints()) {
										mySunkenIsAttacked = true;
									}
								}
								else {
									for (auto & enemyUnitAroundSunken : BWAPI::Broodwar->getUnitsInRadius(sunken->getPosition(), 2 * TILE_SIZE)) {
										if (enemyUnitAroundSunken == nullptr) {
											std::cout << "enemyUnitAroundSunken is null1" << std::endl;
											continue;
										}

										if (enemyUnitAroundSunken->getPlayer() != InformationManager::Instance().selfPlayer) {
											mySunkenIsAttacked = true;
										}
									}
								}

							}
						}
						
						// TODO : region 迡 ϴ  
						//if (BWTA::getRegion(enemyUnitInfo.lastPosition) == myRegion) {
						if (true) {
							
							//   							
							if (unit->getType().isWorker() == false) {

								if (unit->getType() == BWAPI::UnitTypes::Zerg_Zergling
									|| unit->getType() == BWAPI::UnitTypes::Zerg_Hydralisk
									|| unit->getType() == BWAPI::UnitTypes::Zerg_Mutalisk ) 
								{
									// ū ų, ū   
									if (mySunkenCount == 0) {
										mySquad->setUnitMission(unit, Mission(MissionType::AttackMove, enemyUnitInfo.lastPosition));
									}
									else if (mySunkenIsAttacked) {
										mySquad->setUnitMission(unit, Mission(MissionType::AttackMove, enemyUnitInfo.lastPosition));
									}
									else {
										mySquad->setUnitMission(unit, Mission(MissionType::Move, myBaseLocationToDefense->getPosition()));
									}
								}
								else if (unit->getType() == BWAPI::UnitTypes::Zerg_Lurker) {
									mySquad->setUnitMission(unit, Mission(MissionType::AttackMove, myBaseLocationToDefense->getPosition()));
								}
							}							
							// ϲ ο ϰų 
							else {
								if (nonWorkerCountAroundMainBase == 0) {
									if (unit->canBurrow()) {
										unit->burrow();
									}
									else {
										// TODO :  Ҹ ã ġ Ѵ
										//BWAPI::Position targetPosition = StrategyManager::Instance().myMainBaseLocation->getPosition();
										//targetPosition.x += rand() % 15 * TILE_SIZE - 10 * TILE_SIZE;
										//targetPosition.y += rand() % 15 * TILE_SIZE - 10 * TILE_SIZE;

										//mySquad->setUnitMission(unit, Mission(MissionType::Move, targetPosition));
									}
								}
							}

						}
					}
				}
			}


		}
	}
}

void Strategy_CombatTaskManager::blockAndHoldOnChokePoint()
{
	Squad* mySquad = &StrategyManager::Instance().mainChokepointBlockingSquad;
	Mission* unitMission;

	// mainChokepointBlockingSquad  

	// ù°  

	if (StrategyManager::Instance().lastFrameOfConstructHatcheryOnFirstExpansion == 0
		|| StrategyManager::Instance().lastFrameOfConstructHatcheryOnFirstExpansion + 24 * 60 * 1 < BWAPI::Broodwar->getFrameCount()
		|| StrategyManager::Instance().lastFrameOfConstructCreepColonyOnFirstExpansion + 24 * 60 * 1 < BWAPI::Broodwar->getFrameCount())
	{
		BWTA::Chokepoint * targetChokepoint = StrategyManager::Instance().myFirstChokepoint;

		auto & sidePositions = targetChokepoint->getSides();
		BWAPI::Position left = sidePositions.first;
		BWAPI::Position right = sidePositions.second;

		double chokepointWidth = left.getDistance(right);

		int neededUnitCount = (int)(chokepointWidth / 20);


		if (mySquad->unitset.size() > 0) {

			std::vector<BWAPI::Position> targetPositions;

			//   ִ 
			int divideNumber = neededUnitCount;
			if ((int)(mySquad->unitset.size()) < neededUnitCount) {
				divideNumber = (int)(mySquad->unitset.size());
			}

			// 4 ʿϸ, 5
			double gapX = (right.x - left.x) / (neededUnitCount + 1);
			double gapY = (right.y - left.y) / (neededUnitCount + 1);

			for (int i = 0; i < neededUnitCount; i++) {
				targetPositions.push_back(BWAPI::Position((int)(left.x + gapX * i), (int)(left.y + gapY * i)));
			}

			// TODO : 񺸴ٴ      · ִ° 
			int unitIndex = 0;
			for (auto it = mySquad->unitset.begin(); it != mySquad->unitset.end(); it++) {

				unitMission = mySquad->getUnitMission(*it);
				if (unitMission->missionType == MissionType::Mission_Undefined) {
					mySquad->setUnitMission(*it, Mission(MissionType::AttackMove, targetPositions[unitIndex]));
					unitIndex++;
					if (unitIndex == neededUnitCount) {
						break;
					}
				}
			}
		}
	}
	// ϴ,   ԴٰѴ
	else {

		BWTA::Chokepoint * targetChokepoint = StrategyManager::Instance().myFirstChokepoint;

		BWAPI::Position targetPosition = targetChokepoint->getCenter();
		targetPosition.x += (rand() % 6) * TILE_SIZE - 3 * TILE_SIZE;

		for (auto it = mySquad->unitset.begin(); it != mySquad->unitset.end(); it++) {

			unitMission = mySquad->getUnitMission(*it);
			if (unitMission->missionType == MissionType::Mission_Undefined) {
				mySquad->setUnitMission(*it, Mission(MissionType::AttackMove, targetPosition));
			}
		}

	}
}

void Strategy_CombatTaskManager::defensePositionWithHydralisk() {

	Mission* unitMission;

	Squad* currentSquad = &StrategyManager::Instance().mainBaseDefenseSquad;
	if (currentSquad->unitset.size() > 0) {

		for (auto & unit : currentSquad->unitset) {

			unitMission = currentSquad->getUnitMission(unit);

			for (auto & chokepoint : StrategyManager::Instance().frontlineChokepointList) {

				//    л
				if (rand() % 2 == 0) {
					continue;
				}

				if (unitMission->missionType == Mission_Undefined) {
					BWTA::Chokepoint * targetChokepoint = chokepoint;
					if (targetChokepoint != nullptr) {
						currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, targetChokepoint->getCenter()));
					}
				}
			}
		}
	}
}


void Strategy_CombatTaskManager::attackWithLurkerDrop()
{
	Mission* unitMission;

	Squad* currentSquad = &StrategyManager::Instance().mainCombatLurkerSquad;
	if (currentSquad->unitset.size() > 0) {

		for (auto & unit : currentSquad->unitset) {

			unitMission = currentSquad->getUnitMission(unit);
			BWAPI::Position targetPosition = BWAPI::Positions::None;

			double maxDistance = 0;
			double tempDistance = 0;
			for (auto & sunken : BWAPI::Broodwar->self()->getUnits()) {
				if (sunken == nullptr || sunken->exists() == false) continue;

				if (sunken->getType() == BWAPI::UnitTypes::Zerg_Sunken_Colony) {
					tempDistance = StrategyManager::Instance().myFirstExpansionBaseLocation->getPosition().getDistance(sunken->getPosition());
					if (maxDistance < tempDistance) {
						maxDistance = tempDistance;
						targetPosition = sunken->getPosition();
					}
				}
			}

			if (targetPosition == BWAPI::Positions::None)  {
				for (auto & chokepoint : StrategyManager::Instance().frontlineChokepointList) {
					tempDistance = StrategyManager::Instance().myFirstExpansionBaseLocation->getPosition().getDistance(chokepoint->getCenter());
					if (maxDistance < tempDistance) {
						maxDistance = tempDistance;
						targetPosition = chokepoint->getCenter();
					}
				}
			}

			if (targetPosition != BWAPI::Positions::None)  {
				currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, targetPosition));
			}
		}
	}
}

void Strategy_CombatTaskManager::burrowAndAmbushAttackWithLurker()
{
	Mission* unitMission;

	Squad* currentSquad = &StrategyManager::Instance().ambushCombatLurkerSquad;
	if (currentSquad->unitset.size() > 0) {

		for (auto & unit : currentSquad->unitset) {

			unitMission = currentSquad->getUnitMission(unit);

			// Ʊ   frontlone   ο, ̸   ãƼ ο  ִ´
			BWAPI::Position targetPosition = StrategyManager::Instance().enemyFirstExpansionBaseLocation->getPosition();

			std::list<BWTA::Chokepoint*> chokepointList = BWTA::getShortestPath2(
				BWAPI::TilePosition(StrategyManager::Instance().frontlinePosition.x / TILE_SIZE, StrategyManager::Instance().frontlinePosition.y / TILE_SIZE),
				BWAPI::TilePosition(targetPosition));

			while (chokepointList.size() > 2) {
				chokepointList.pop_front();
			}
			BWTA::Chokepoint* targetChokepoint = chokepointList.front();
			targetPosition = targetChokepoint->getCenter();
						
			if (targetPosition != BWAPI::Positions::None)  {
				currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, targetPosition));
			}
		}
	}

}


void Strategy_CombatTaskManager::attackEnemyWithMainCombatMutaliskSquad()
{
	//   
	BWAPI::Position targetAttackPosition = BWAPI::Positions::None;
	bool isToAttackBaseLocation = false;

	Squad* currentSquad = &StrategyManager::Instance().mainCombatMutaliskSquad;

	// Żũ Ը      ְ Ѵ
	if (flyingState == FlyingState::moveToSafePosition) {

		//targetAttackPosition = StrategyManager::Instance().myMainBaseLocation->getPosition();
		targetAttackPosition = StrategyManager::Instance().getSafePosition(mainCombatMutaliskSquadCenterPosition);
		isToAttackBaseLocation = false;

		moveMutaliskSquad(targetAttackPosition, isToAttackBaseLocation);

		if (currentSquad->unitset.size() >= 8) {
			flyingState = FlyingState::searchForTarget;
		}
	}
	else {
		// Ż ڰ  پ, ٽ  ҷ ư
		if (currentSquad->unitset.size() < 4) {
			flyingState = FlyingState::moveToSafePosition;
		}
		else {

			// غ  BaseLocation  ãƺ
			/*
			BWTA::BaseLocation * targetBaseLocation = getWeakestEnemyBaseLocationForMutalisk();
			if (targetBaseLocation != nullptr) {
			targetAttackPosition = targetBaseLocation->getPosition();
			}
			else {
			// غ   ãƺ
			targetAttackPosition = getTargetPositionInMapToAttackWithMutalisk();
			}
			*/
			targetAttackPosition = getTargetPositionToAttackWithMutalisk();
			isToAttackBaseLocation = false;

			// Ҹ   
			if (targetAttackPosition == BWAPI::Positions::None) {

				//  ո Ȱ Ǿ 
				if (StrategyManager::Instance().enemyFirstExpansionBaseLocation != nullptr) {
					if (StrategyManager::Instance().baseLocationStatusMap[StrategyManager::Instance().enemyFirstExpansionBaseLocation].lastVisibleTime < 0
						|| BWAPI::Broodwar->getFrameCount() - StrategyManager::Instance().baseLocationStatusMap[StrategyManager::Instance().enemyFirstExpansionBaseLocation].lastVisibleTime >= 20 * 60 * 2)
					{
						targetAttackPosition = StrategyManager::Instance().enemyFirstExpansionBaseLocation->getPosition();
						isToAttackBaseLocation = true;
					}
				}
			}

			// TODO :  next Ƽ Ȱ Ǿ 
				
			//   Ȱ Ǿ 
			if (targetAttackPosition == BWAPI::Positions::None) {
				if (StrategyManager::Instance().enemyMainBaseLocation != nullptr) {
					if (StrategyManager::Instance().baseLocationStatusMap[StrategyManager::Instance().enemyMainBaseLocation].lastVisibleTime < 0
						|| BWAPI::Broodwar->getFrameCount() - StrategyManager::Instance().baseLocationStatusMap[StrategyManager::Instance().enemyMainBaseLocation].lastVisibleTime >= 20 * 60 * 2)
					{
						targetAttackPosition = StrategyManager::Instance().enemyMainBaseLocation->getPosition();
						isToAttackBaseLocation = true;
					}
				}
			}
				
			// Ҹ   Ѱ  Ż ڸ  
			if (targetAttackPosition == BWAPI::Positions::None) {
				targetAttackPosition = StrategyManager::Instance().getSafePosition(mainCombatMutaliskSquadCenterPosition);
				isToAttackBaseLocation = false;
			}

			BWAPI::Broodwar->drawCircleMap(targetAttackPosition, 1 * TILE_SIZE, BWAPI::Colors::Red);
			BWAPI::Broodwar->drawCircleMap(targetAttackPosition, 3 * TILE_SIZE, BWAPI::Colors::Red);
			BWAPI::Broodwar->drawCircleMap(targetAttackPosition, 5 * TILE_SIZE, BWAPI::Colors::Red);


			moveMutaliskSquad(targetAttackPosition, isToAttackBaseLocation);
		}
	}
}

void Strategy_CombatTaskManager::attackEnemyWithEarlyZerglingSquad()
{
	Squad* currentSquad = &StrategyManager::Instance().mainCombatZerglingSquad;
	if (currentSquad->unitset.size() == 0) {
		return;
	}

	BWTA::BaseLocation * enemyMainBaseLocation = InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().enemyPlayer);
	if (enemyMainBaseLocation == nullptr) {
		return;
	}	
	
	// ۸  ̱ Ȳ̸  :      
	// TODO : ۸ ȸؼ  ϲ ̶ ̰ų
	// Ȥ Ʊ  ó  ߾     Ժη   ؾ
	if (isImpossibleToWinTheCombat()) {
		for (auto & unit : currentSquad->unitset) {
			currentSquad->setUnitMission(unit, Mission(MissionType::Move, StrategyManager::Instance().myFirstExpansionBaseLocation->getPosition()));
		}
	}
	// ۸ οϸ 
	else {
		BWAPI::Unit enemyUnitAroundEnemyChokepointClosestToOurBase = getEnemyUnitAroundEnemyChokepointClosestToEnemyFirstExpansionLocation();
		BWAPI::Unit mostUrgentTarget = getMostUrgentEnemyUnit();

		BWAPI::Broodwar->drawCircleMap(StrategyManager::Instance().enemyFirstChokepoint->getCenter(), 4 * TILE_SIZE, BWAPI::Colors::Red);
		if (enemyUnitAroundEnemyChokepointClosestToOurBase != nullptr) {
			BWAPI::Broodwar->drawCircleMap(enemyUnitAroundEnemyChokepointClosestToOurBase->getPosition(), 1 * TILE_SIZE, BWAPI::Colors::Red);
		}
		if (mostUrgentTarget != nullptr) {
			BWAPI::Broodwar->drawCircleMap(mostUrgentTarget->getPosition(), 1 * TILE_SIZE, BWAPI::Colors::Yellow);
		}
		if (concentrationAttackTargetUnit != nullptr) {
			BWAPI::Broodwar->drawCircleMap(concentrationAttackTargetUnit->getPosition(), 1 * TILE_SIZE, BWAPI::Colors::Blue);
		}

		for (auto & unit : currentSquad->unitset) {

			if (unit == nullptr || unit->exists() == false || unit->getHitPoints() == 0 || unit->isCompleted() == false) continue;

			Mission* unitMission = currentSquad->getUnitMission(unit);
			bool hasOrderedNewMission = false;

			// ش ۸  Ÿ
			BWAPI::Unit targetUnit = nullptr;
			if (attackerTargetMap.find(unit) != attackerTargetMap.end()) {
				targetUnit = attackerTargetMap[unit];
			}

			//  Ÿ    ִ   δ
			if (targetUnit != nullptr 
				&& targetUnit->getDistance(unit->getPosition()) < 32
				&& targetUnit->exists() 
				&& targetUnit->isFlying() == false
				&& targetUnit->getHitPoints() < targetUnit->getType().maxHitPoints() * 0.2)
			{
				currentSquad->setUnitMission(unit, Mission(MissionType::Attack, targetUnit));
				hasOrderedNewMission = true;
			}
			//  Ÿ ų,  ̷   , ٸ Ÿ ٲ ϴ Ѵ
			else {

				//    ôٸ  ̵
				if (BWAPI::Broodwar->isExplored(BWAPI::TilePosition(StrategyManager::Instance().enemyFirstChokepoint->getCenter())) == false) {
					//std::cout << "Move to enemyFirstChokepoint ";
					//std::cout << " " << unit->getID() << " M F";
					currentSquad->setUnitMission(unit, Mission(MissionType::Move, StrategyManager::Instance().enemyFirstChokepoint->getCenter()));
					hasOrderedNewMission = true;
				}

				if (hasOrderedNewMission == false) {

					//   ؼҼ 
					if (isEasyToKillEnemyCombatUnitsWithZergling() )
					{
						//  /ǹ    װ  
						if (enemyCombatUnitAroundEnemyChokepoint + enemyDefenseBuildingAroundEnemyBase
							+ enemyWorkerUnitAroundEnemyChokepoint >= 2) {

							if (enemyUnitAroundEnemyChokepointClosestToOurBase != nullptr && enemyUnitAroundEnemyChokepointClosestToOurBase->exists() && enemyUnitAroundEnemyChokepointClosestToOurBase->getHitPoints() > 0) {
								//std::cout << "Attack enemyUnitAroundEnemyChokepointClosestToOurBase" << std::endl;
								//std::cout << " " << unit->getID() << " A CH " << targetUnit->getType().getName().c_str() << " " << targetUnit->getID();
								currentSquad->setUnitMission(unit, Mission(MissionType::Attack, enemyUnitAroundEnemyChokepointClosestToOurBase));
								attackerTargetMap[unit] = nullptr;
								hasOrderedNewMission = true;
							}
							else {
								//std::cout << "AttackMove enemyFirstChokepoint" << std::endl;
								//std::cout << " " << unit->getID() << " AM CH";
								currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, StrategyManager::Instance().enemyFirstChokepoint->getCenter()));
								attackerTargetMap[unit] = nullptr;
								hasOrderedNewMission = true;
							}
						}
						//  ϲ   ʴٸ, 
						else {
							//   ǹ  ôٸ  ̵
							if (BWAPI::Broodwar->isExplored(BWAPI::TilePosition(StrategyManager::Instance().enemyMainBaseLocation->getPosition())) == false) {
								//std::cout << "Move to enemyMainBaseLocation ";
								//std::cout << " " << unit->getID() << " M B";
								currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, StrategyManager::Instance().enemyMainBaseLocation->getPosition()));
								hasOrderedNewMission = true;
							}
						}

						//  񸷰ִ ϲ۵ ,   ǹ ̹ ôٸ
						if (hasOrderedNewMission == false) {

							//    ,    ϳ Ƽ ߰
							if (enemyCombatUnitCount > 0) {

								if (concentrationAttackTargetUnit == nullptr || concentrationAttackTargetUnit->exists() == false || concentrationAttackTargetUnit->getHitPoints() == 0 || concentrationAttackTargetUnit->isVisible() == false) {
									//     ƹ ϳ  ´
									concentrationAttackTargetUnit = getNearestAndWeakestEnemyGroundCombatUnit(unit->getPosition());
								}

								if (concentrationAttackTargetUnit != nullptr && concentrationAttackTargetUnit->exists() && concentrationAttackTargetUnit->getHitPoints() > 0) {

									//  ȸ¾  ο
									if (unit->getHitPoints() > 10) {
										targetUnit = concentrationAttackTargetUnit;
										currentSquad->setUnitMission(unit, Mission(MissionType::Attack, targetUnit));
										//std::cout << "Attack concentrationAttackTargetUnit " << targetUnit->getID() << " " << targetUnit->getType().getName().c_str() << std::endl;
										//std::cout << " " << unit->getID() << " " << unit->getHitPoints() << " A CO " << targetUnit->getType().getName().c_str() << " " << targetUnit->getID();
										attackerTargetMap[unit] = targetUnit;
										hasOrderedNewMission = true;
									}
									//  ¾ ڷ 
									else {
										// ο ̾ų ̵ϴ ̾ ̵ ġ  
										if (unitMission->missionType == MissionType::Attack || unitMission->missionType == MissionType::AttackMove || unitMission->missionType == MissionType::Move) {

											// ̿  ü  Ʊ ֹۿ   ο
											// ̿ ü  Ʊ   ٸ  ̵Ų
											if (isThereHealthyFriendUnitAround(unit->getPosition(), 4 * TILE_SIZE)) {

												// 켱   ǹ Ϸ  Ѵ
												if (mostUrgentTarget != nullptr && mostUrgentTarget->exists() && mostUrgentTarget->getHitPoints() > 0) {
													targetUnit = mostUrgentTarget;
													currentSquad->setUnitMission(unit, Mission(MissionType::Attack, targetUnit));
													//std::cout << "Attack mostUrgentTarget " << targetUnit->getID() << " " << targetUnit->getType().getName().c_str() << std::endl;
													//std::cout << " " << unit->getID() << " A U " << targetUnit->getType().getName().c_str() << " " << targetUnit->getID();
													attackerTargetMap[unit] = targetUnit;
													hasOrderedNewMission = true;
												}

												if (hasOrderedNewMission == false) {
													// ܼϰ  ո ̵
													BWAPI::Position targetPosition = StrategyManager::Instance().enemyFirstExpansionBaseLocation->getPosition();
													currentSquad->setUnitMission(unit, Mission(MissionType::Move, targetPosition));
													//std::cout << "Move Flee " << unit->getID() << " to " << targetPosition.x << "," << targetPosition.y << std::endl;
													//std::cout << " " << unit->getID() << " " << unit->getHitPoints() << " M F to " << targetPosition.x << "," << targetPosition.y << std::endl;
													attackerTargetMap[unit] = targetUnit;
													hasOrderedNewMission = true;
												}
											}
										}
										// ڷ ̵  , ٽ 
										else if (unitMission->missionType == MissionType::Mission_Undefined) {
											targetUnit = concentrationAttackTargetUnit;
											currentSquad->setUnitMission(unit, Mission(MissionType::Attack, targetUnit));
											//std::cout << "Attack concentrationAttackTargetUnit " << targetUnit->getID() << " " << targetUnit->getType().getName().c_str() << std::endl;
											//std::cout << " " << unit->getID() << " " << unit->getHitPoints() << " A CO " << targetUnit->getType().getName().c_str() << " " << targetUnit->getID();
											attackerTargetMap[unit] = targetUnit;
											hasOrderedNewMission = true;
										}
									}
								}
							}
							//    
							else {
								//   ǹ  켱ݴ ǹ mostUrgentTarget  
								if (mostUrgentTarget != nullptr && mostUrgentTarget->exists() && mostUrgentTarget->getHitPoints() > 0) {

									// mostUrgentTarget  ִ 6 δ
									if (getNumberOfSameTargeting(mostUrgentTarget) < 6) {
										targetUnit = mostUrgentTarget;
										currentSquad->setUnitMission(unit, Mission(MissionType::Attack, targetUnit));
										//std::cout << "Attack mostUrgentTarget " << targetUnit->getID() << " " << targetUnit->getType().getName().c_str() << std::endl;
										std::cout << " " << unit->getID() << " A U " << targetUnit->getType().getName().c_str() << " " << targetUnit->getID();
										attackerTargetMap[unit] = targetUnit;
										hasOrderedNewMission = true;
									}
								}
							}
						}
					}
				}
			}
					
			//    ټ ־ ְ   ʱ  ϲ 
			//     ,   ǹ      Ȳ Ǿ ϲ 
			if (hasOrderedNewMission == false) {

				if (enemyWorkerUnitCount > 0) {

					bool isToFindAnotherTarget = false;

					if (targetUnit == nullptr) {
						isToFindAnotherTarget = true;
					}
					else {
						//  Ÿ  , ϲ Ÿ 
						if (targetUnit->getType().isWorker() == false && targetUnit->getHitPoints() >= 35) {
							isToFindAnotherTarget = true;
						}
					}

					if (isToFindAnotherTarget){

						//    ϲ ϳ   :  ϲ 1 Ʊ ۸ 3 ϵ Ѵ
						BWAPI::Unit closestEnemyWorker = getNearestEnemyWorkerForMeleeAttack(unit->getPosition(), 3);

						// ̿  ϲ  
						if (closestEnemyWorker != nullptr && closestEnemyWorker->exists() && closestEnemyWorker->getHitPoints() > 0) {
							targetUnit = closestEnemyWorker;
							currentSquad->setUnitMission(unit, Mission(MissionType::Attack, targetUnit));
							//std::cout << "Attack closestEnemyWorker Worker " << targetUnit->getID() << " " << targetUnit->getType().getName().c_str() << std::endl;
							//std::cout << " " << unit->getID() << " A CL " << targetUnit->getType().getName().c_str() << " " << targetUnit->getID();
							attackerTargetMap[unit] = targetUnit;
							hasOrderedNewMission = true;
						}								
					}
				}
				//  ϲ  
				else {							
					//  ̳׶  Ⱥ, ̳׶ ġ ̵ؼ  ϲ  ãƺ
					if (isAllMineralExplored(StrategyManager::Instance().enemyMainBaseLocation) == false) {
						BWAPI::Position targetPosition = getFarthestMineralPosition(unit->getPosition(), StrategyManager::Instance().enemyMainBaseLocation);						
						currentSquad->setUnitMission(unit, Mission(MissionType::Move, targetPosition));
						hasOrderedNewMission = true;
					}	
				}
			}

			//    , 켱ݴ ǹ mostUrgentTarget  , ϲ , ٸ Ϲ ǹ /  Ѵ
			if (hasOrderedNewMission == false) {

				BWAPI::Position targetPosition = getNearestEnemyUnitToGroundAttack(unit->getPosition());
				if (targetPosition != BWAPI::Positions::None) {
					currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, targetPosition));
					hasOrderedNewMission = true;
				}
			}

			//    , ⺻    AttackMove 
			if (hasOrderedNewMission == false) {
				//std::cout << "Move to enemyMainBaseLocation ";
				//std::cout << " " << unit->getID() << " M B";
				currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, StrategyManager::Instance().enemyMainBaseLocation, StrategyManager::Instance().enemyMainBaseLocation->getPosition()));
			}
		}
	}

	BWAPI::Broodwar->drawTextScreen(300, 250, "zerglingScouterNumberFromCombatSquad : %d", StrategyManager::Instance().zerglingScouterNumberFromCombatSquad);
}

void Strategy_CombatTaskManager::attackEnemyWithMainCombatGroundSquad()
{
	// Ӿ    Ȯ
	//  : Zergling  BaseLocation  , 񸶴 ´
	//  : Queen  , Parasite   Ȱ

	// Ʊ  þ߹    ų, Ʊ    , ȲǴ

	// Ʊ BaseLocation  ִ Region   ݹ  

	// Ʊ Ϸ  Ϳ ־
	//  ǥ  ->   ܰ ChokePoint  ̵.  ֵ 50% ̸  ChokePoint  ̵
	//  ǥ  ->   ٷ   Ҹ ؼ . ׳  ߿ ߰ǰ, ݴ. , ڸ Ƽ ̵ؾ.

	bool isToRetreat = false;


	/*
	if (InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Terran_Vulture, InformationManager::Instance().enemyPlayer) >= 1
		|| InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Terran_Bunker, InformationManager::Instance().enemyPlayer) >= 1
		|| InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Terran_Siege_Tank_Siege_Mode, InformationManager::Instance().enemyPlayer) >= 1
		|| InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Terran_Siege_Tank_Tank_Mode, InformationManager::Instance().enemyPlayer) >= 1
		|| InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Terran_Goliath, InformationManager::Instance().enemyPlayer) >= 1
		|| InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Protoss_Dragoon, InformationManager::Instance().enemyPlayer) >= 1
		|| InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Protoss_Photon_Cannon, InformationManager::Instance().enemyPlayer) >= 1
		|| InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Protoss_Archon, InformationManager::Instance().enemyPlayer) >= 1
		|| InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Zerg_Hydralisk, InformationManager::Instance().enemyPlayer) >= 1
		|| InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Zerg_Mutalisk, InformationManager::Instance().enemyPlayer) >= 1
		|| InformationManager::Instance().getNumUnits(BWAPI::UnitTypes::Zerg_Sunken_Colony, InformationManager::Instance().enemyPlayer) >= 1
		)
	{
		isToRetreat = true;
	}
	*/

	Squad* currentSquad = nullptr;

	int totalSquadSize = StrategyManager::Instance().mainCombatZerglingSquad.unitset.size() 
		+ StrategyManager::Instance().mainCombatHydraliskSquad.unitset.size()
		+ StrategyManager::Instance().mainCombatLurkerSquad.unitset.size()
		+ StrategyManager::Instance().mainCombatUltraliskSquad.unitset.size() 
		+ StrategyManager::Instance().mainCombatQueenSquad.unitset.size()
		+ StrategyManager::Instance().mainCombatDefilerSquad.unitset.size()
		+ StrategyManager::Instance().mainCombatScourgeSquad.unitset.size()
		+ StrategyManager::Instance().mainCombatMutaliskSquad.unitset.size();

	//  Ҹ Ȳ Ǳ   մϴ
	if (combatState == CombatState::defenseMode) {

		// Ʊ  ǹ ִ ġ
		targetAssemblePositionForGroundUnits = StrategyManager::Instance().myFirstExpansionBaseLocation->getPosition();
		targetAttackPositionForGroundUnits = targetAssemblePositionForGroundUnits;


		/// Ʊ  鿡  մϴ
		// Ʊ   ǹ ִ ġ ġŵϴ
		// Ʊ  Ʊ  ǹ ʿ ġ״ٰ   ǹ ϱ   Բ οϸ   Դϴ
		
		for (int i = 0; i <= 7; i++) {
			if (i == 0) currentSquad = &StrategyManager::Instance().mainCombatZerglingSquad;
			else if (i == 1) currentSquad = &StrategyManager::Instance().mainCombatHydraliskSquad;
			else if (i == 2) currentSquad = &StrategyManager::Instance().mainCombatLurkerSquad;
			else if (i == 3) currentSquad = &StrategyManager::Instance().mainCombatUltraliskSquad;
			else if (i == 4) currentSquad = &StrategyManager::Instance().mainCombatQueenSquad;
			else if (i == 5) currentSquad = &StrategyManager::Instance().mainCombatDefilerSquad;
			else if (i == 6) currentSquad = &StrategyManager::Instance().mainCombatScourgeSquad;
			else if (i == 7) currentSquad = &StrategyManager::Instance().mainCombatMutaliskSquad;

			for (auto & unit : currentSquad->unitset) {
				currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, targetAttackPositionForGroundUnits));
			}
		}

		///   ȯ  θ Ǵմϴ
		if (isTimeToStartAttack()) {
			combatState = CombatState::gatherToAttack;
		}
	}
	//  忡  մϴ 
	else {

		BWTA::BaseLocation* targetBaseLocation = getWeakestEnemyBaseLocationForGroundCombatUnit();

		if (targetBaseLocation == nullptr) {
			return;
		}

		///   ȯ  θ Ǵմϴ
		if (isTimeToRetreatFromCombat()) {
			combatState = CombatState::defenseMode;
			return;
		}

		// TODO : ΰݺδ δ Բ   Ѵ
		// TODO : δ ΰݺδ ġ attackMove Ų

		// Ʊ  ֵ鿡 frontlinePosition  ̵ մϴ 
		if (combatState == CombatState::gatherToAttack) {

			targetAssemblePositionForGroundUnits = StrategyManager::Instance().frontlinePosition;
			targetAttackPositionForGroundUnits = targetAssemblePositionForGroundUnits;

			if (getMyUnitCount(targetAttackPositionForGroundUnits, 8 * TILE_SIZE) > totalSquadSize * 0.5) {
				combatState = CombatState::prepareToAttackStart;
			}

		}
		// Ʊ  ֵ鿡 ݴ ̽     ̵ մϴ 
		else if (combatState == CombatState::prepareToAttackStart) {
			
			targetAssemblePositionForGroundUnits = getAssemblePositionForGroundAttack(StrategyManager::Instance().frontlinePosition, targetBaseLocation->getPosition());
			targetAttackPositionForGroundUnits = targetAssemblePositionForGroundUnits;

			if (getMyUnitCount(targetAttackPositionForGroundUnits, 8 * TILE_SIZE) > totalSquadSize * 0.5) {
				combatState = CombatState::attackEnemyChokepoint1;
			}
		}
		// Ʊ  ֵ鿡 targetBaseLocation    ߰   մϴ 
		else if (combatState == CombatState::attackEnemyChokepoint1) {

			targetAssemblePositionForGroundUnits = getAssemblePositionForGroundAttack(
				getAssemblePositionForGroundAttack(StrategyManager::Instance().frontlinePosition, targetBaseLocation->getPosition()),
				targetBaseLocation->getPosition());

			targetAttackPositionForGroundUnits = targetAssemblePositionForGroundUnits;

			if (getMyUnitCount(targetAttackPositionForGroundUnits, 8 * TILE_SIZE) > totalSquadSize * 0.5) {
				combatState = CombatState::attackEnemyChokepoint2;
			}
		}
		else if (combatState == CombatState::attackEnemyChokepoint2) {
			
			targetAssemblePositionForGroundUnits = getAssemblePositionForGroundAttack(
				getAssemblePositionForGroundAttack(StrategyManager::Instance().frontlinePosition, targetBaseLocation->getPosition()),
				targetBaseLocation->getPosition());

			std::list<BWTA::Chokepoint*> chokepointList = BWTA::getShortestPath2(
				BWAPI::TilePosition(targetAssemblePositionForGroundUnits),
				targetBaseLocation->getTilePosition());

			if (chokepointList.size() <= 1) {
				combatState = CombatState::attackEnemyBaseLocation;
				return;
			}
			else {
				chokepointList.pop_front();
				BWTA::Chokepoint* targetChokepoint = chokepointList.front();
				if (targetChokepoint != nullptr) {
					targetAttackPositionForGroundUnits = targetChokepoint->getCenter();

					if (getMyUnitCount(targetAttackPositionForGroundUnits, 8 * TILE_SIZE) > totalSquadSize * 0.5) {
						combatState = CombatState::attackEnemyChokepoint3;
					}
				}
			}
		}
		else if (combatState == CombatState::attackEnemyChokepoint3) {
			
			targetAssemblePositionForGroundUnits = getAssemblePositionForGroundAttack(
				getAssemblePositionForGroundAttack(StrategyManager::Instance().frontlinePosition, targetBaseLocation->getPosition()),
				targetBaseLocation->getPosition());

			std::list<BWTA::Chokepoint*> chokepointList = BWTA::getShortestPath2(
				BWAPI::TilePosition(targetAssemblePositionForGroundUnits),
				targetBaseLocation->getTilePosition());

			if (chokepointList.size() <= 2) {
				combatState = CombatState::attackEnemyBaseLocation;
				return;
			}
			else {
				chokepointList.pop_front();
				chokepointList.pop_front();
				BWTA::Chokepoint* targetChokepoint = chokepointList.front();
				if (targetChokepoint != nullptr) {
					targetAttackPositionForGroundUnits = targetChokepoint->getCenter();

					if (getMyUnitCount(targetAttackPositionForGroundUnits, 8 * TILE_SIZE) > totalSquadSize * 0.5) {
						combatState = CombatState::attackEnemyBaseLocation;
					}
				}
			}
		}
		else if (combatState == CombatState::attackEnemyBaseLocation) {

			targetAssemblePositionForGroundUnits = BWTA::getNearestChokepoint(targetBaseLocation->getPosition())->getCenter();

			targetAttackPositionForGroundUnits = targetBaseLocation->getPosition();
		}

		// Ʊ ݺδ뿡 targetAttackPositionForGroundUnits   մϴ
		Squad* currentSquad = nullptr;

		for (int i = 0; i <= 5; i++) {
			if (i == 0) currentSquad = &StrategyManager::Instance().mainCombatZerglingSquad;
			else if (i == 1) currentSquad = &StrategyManager::Instance().mainCombatHydraliskSquad;
			else if (i == 2) currentSquad = &StrategyManager::Instance().mainCombatLurkerSquad;
			else if (i == 3) currentSquad = &StrategyManager::Instance().mainCombatUltraliskSquad;
			else if (i == 4) currentSquad = &StrategyManager::Instance().mainCombatQueenSquad;
			else if (i == 5) currentSquad = &StrategyManager::Instance().mainCombatDefilerSquad;

			for (auto & unit : currentSquad->unitset) {
				currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, targetAttackPositionForGroundUnits));
			}
		}
	}
}


void Strategy_CombatTaskManager::updateUnitMissionForZerglingAsFindEnemyMainBaseLocation()
{
}

void Strategy_CombatTaskManager::updateUnitMissionForZerglingAsFastAttack()
{
}

void Strategy_CombatTaskManager::updateUnitMissionForZerglingAsEliminateAttack()
{
	/*
	bool isToReassignUnitMission = false;
	BWAPI::Unit targetEnemyUnit = nullptr;
	BWAPI::Position targetEnemyUnitPosition = BWAPI::Positions::None;
	BWTA::BaseLocation * enemyMainBaseLocation = InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().enemyPlayer);

	// ۸ ,  MainBaseLocation   
	for (auto & unit : BWAPI::Broodwar->self()->getUnits())
	{
		if (unit == nullptr || unit->exists() == false || unit->getHitPoints() == 0 || unit->isCompleted() == false) continue;

		if (unit->getType() == BWAPI::UnitTypes::Zerg_Zergling)
		{
			if (enemyMainBaseLocation != nullptr)
			{
				int enemyCombatUnitCount = InformationManager::Instance().getNumUnits(InformationManager::Instance().getBasicCombatUnitType(InformationManager::Instance().enemyRace), InformationManager::Instance().enemyPlayer);
				int enemyWorkerUnitCount = InformationManager::Instance().getNumUnits(InformationManager::Instance().getWorkerType(InformationManager::Instance().enemyRace), InformationManager::Instance().enemyPlayer);
				// Ϸ, Ŀ, ũݷδ
				int enemyBasicDepenseBuildingCount = InformationManager::Instance().getNumUnits(InformationManager::Instance().getBasicDefenseBuildingType(InformationManager::Instance().enemyRace), InformationManager::Instance().enemyPlayer);
				// ĳ, ͷ, ūݷδ
				int enemyAdvancedDepenseBuildingCount = InformationManager::Instance().getNumUnits(InformationManager::Instance().getAdvancedDefenseBuildingType(InformationManager::Instance().enemyRace), InformationManager::Instance().enemyPlayer);

				//std::cout << "enemyCombatUnitCount : " << enemyCombatUnitCount << ", enemyWorkerUnitCount : " << enemyWorkerUnitCount << std::endl;

				bool hasOrderedNewMission = false;

				int selfZerglingCount = BWAPI::Broodwar->self()->completedUnitCount(BWAPI::UnitTypes::Zerg_Zergling);
				if (selfZerglingCount >= 40) {

					//   
					if (true) {

						if (targetEnemyUnit == nullptr) {

							//     ϳ  
							int minDistanceToAttack = INT_MAX;
							int tempDistanceToAttack;
							int minHitPointToAttack = INT_MAX;
							int tempHitPointToAttack;

							// BWAPI::Broodwar->enemy()->getUnits  ϸ, Ʊ ðŸ   ȸȵȴ
							// ׷, InformationManager::Instance().getUnitAndUnitInfoMap  ؾ Ѵ
							for (auto & it : InformationManager::Instance().getUnitAndUnitInfoMap(InformationManager::Instance().enemyPlayer))
							{
								BWAPI::Unit enemyUnit = it.first;
								const UnitInfo & enemyUnitInfo = it.second;


								if (enemyUnitInfo.type == InformationManager::Instance().getBasicCombatUnitType(InformationManager::Instance().enemyRace))
								{
									tempDistanceToAttack = unit->getDistance(enemyUnitInfo.lastPosition);
									if (tempDistanceToAttack < minDistanceToAttack) {
										minDistanceToAttack = tempDistanceToAttack;

										targetEnemyUnit = enemyUnit;
										targetEnemyUnitPosition = enemyUnitInfo.lastPosition;
									}
									else if (tempDistanceToAttack == minDistanceToAttack) {
										tempHitPointToAttack = enemyUnitInfo.lastHealth + enemyUnitInfo.lastShields;
										if (tempHitPointToAttack < minHitPointToAttack) {
											minHitPointToAttack = tempHitPointToAttack;

											targetEnemyUnit = enemyUnit;
											targetEnemyUnitPosition = enemyUnitInfo.lastPosition;
										}
									}
								}
							}
						}

						if (targetEnemyUnit != nullptr) {
							setUnitMission(unit, Mission(MissionType::Attack, targetEnemyUnit));
							hasOrderedNewMission = true;
						}
					}
					else if (enemyWorkerUnitCount > 0) {

						if (targetEnemyUnit == nullptr) {

							//    ϲ ϳ  
							int minDistanceToAttack = INT_MAX;
							int tempDistanceToAttack;
							int minHitPointToAttack = INT_MAX;
							int tempHitPointToAttack;

							for (auto & it : InformationManager::Instance().getUnitAndUnitInfoMap(InformationManager::Instance().enemyPlayer))
							{
								BWAPI::Unit enemyUnit = it.first;
								const UnitInfo & enemyUnitInfo = it.second;

								if (enemyUnitInfo.type == InformationManager::Instance().getWorkerType(InformationManager::Instance().enemyRace))
								{
									tempDistanceToAttack = unit->getDistance(enemyUnitInfo.lastPosition);
									if (tempDistanceToAttack < minDistanceToAttack) {
										minDistanceToAttack = tempDistanceToAttack;
										targetEnemyUnit = enemyUnit;
										targetEnemyUnitPosition = enemyUnitInfo.lastPosition;
									}
									else if (tempDistanceToAttack == minDistanceToAttack) {
										tempHitPointToAttack = enemyUnitInfo.lastHealth + enemyUnitInfo.lastShields;
										if (tempHitPointToAttack < minHitPointToAttack) {
											minHitPointToAttack = tempHitPointToAttack;
											targetEnemyUnit = enemyUnit;
											targetEnemyUnitPosition = enemyUnitInfo.lastPosition;
										}
									}
								}
							}
						}

						if (targetEnemyUnit != nullptr) {
							setUnitMission(unit, Mission(MissionType::Attack, targetEnemyUnit));
							hasOrderedNewMission = true;
						}
					}
					if (hasOrderedNewMission == false) {
						setUnitMission(unit, Mission(MissionType::Move, nullptr, InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().enemyPlayer)->getPosition()));
					}
				}
				else if (selfZerglingCount >= 12) {
					for (BWTA::BaseLocation * baseLocation : BWTA::getBaseLocations()) {
						if (baseLocation == InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().enemyPlayer)) continue;

						if (unit->isIdle()) {
							if (rand() % 10 == 0) {
								setUnitMission(unit, Mission(MissionType::AttackMove, nullptr, baseLocation->getPosition()));
							}
						}
					}
				}
			}
		}
	}
	*/
}


void Strategy_CombatTaskManager::updateUnitMissionForMutaliskAsAttack()
{
	/*
	bool isToReassignUnitMission = false;
	BWAPI::Unit targetEnemyUnit = nullptr;
	BWAPI::Position targetEnemyUnitPosition = BWAPI::Positions::None;
	BWTA::BaseLocation * enemyMainBaseLocation = InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().enemyPlayer);

	for (auto & unit : BWAPI::Broodwar->self()->getUnits())
	{
		if (unit == nullptr || unit->exists() == false || unit->getHitPoints() == 0 || unit->isCompleted() == false) continue;

		if (unit->getType() == BWAPI::UnitTypes::Zerg_Mutalisk)
		{
			if (enemyMainBaseLocation != nullptr)
			{
				int enemyCombatUnitCount = InformationManager::Instance().getNumUnits(InformationManager::Instance().getBasicCombatUnitType(InformationManager::Instance().enemyRace), InformationManager::Instance().enemyPlayer);
				int enemyWorkerUnitCount = InformationManager::Instance().getNumUnits(InformationManager::Instance().getWorkerType(InformationManager::Instance().enemyRace), InformationManager::Instance().enemyPlayer);
				// Ϸ, Ŀ, ũݷδ
				int enemyBasicDepenseBuildingCount = InformationManager::Instance().getNumUnits(InformationManager::Instance().getBasicDefenseBuildingType(InformationManager::Instance().enemyRace), InformationManager::Instance().enemyPlayer);
				// ĳ, ͷ, ūݷδ
				int enemyAdvancedDepenseBuildingCount = InformationManager::Instance().getNumUnits(InformationManager::Instance().getAdvancedDefenseBuildingType(InformationManager::Instance().enemyRace), InformationManager::Instance().enemyPlayer);

				//std::cout << "enemyCombatUnitCount : " << enemyCombatUnitCount << ", enemyWorkerUnitCount : " << enemyWorkerUnitCount << std::endl;

				bool hasOrderedNewMission = false;

				int selfMutaliskCount = BWAPI::Broodwar->self()->completedUnitCount(BWAPI::UnitTypes::Zerg_Mutalisk);
				if (selfMutaliskCount >= 9) {
					//    ȵǸ  . ʹ  ׳ ϲ۸ δ
					if (enemyCombatUnitCount > 0 && enemyCombatUnitCount <= 6) {

						if (targetEnemyUnit == nullptr) {

							//     ϳ  
							int minDistanceToAttack = INT_MAX;
							int tempDistanceToAttack;
							int minHitPointToAttack = INT_MAX;
							int tempHitPointToAttack;

							// BWAPI::Broodwar->enemy()->getUnits  ϸ, Ʊ ðŸ   ȸȵȴ
							// ׷, InformationManager::Instance().getUnitAndUnitInfoMap  ؾ Ѵ
							for (auto & it : InformationManager::Instance().getUnitAndUnitInfoMap(InformationManager::Instance().enemyPlayer))
							{
								BWAPI::Unit enemyUnit = it.first;
								const UnitInfo & enemyUnitInfo = it.second;

								if (enemyUnitInfo.type == InformationManager::Instance().getBasicCombatUnitType(InformationManager::Instance().enemyRace))
								{
									tempDistanceToAttack = unit->getDistance(enemyUnitInfo.lastPosition);
									if (tempDistanceToAttack < minDistanceToAttack) {
										minDistanceToAttack = tempDistanceToAttack;

										targetEnemyUnit = enemyUnit;
										targetEnemyUnitPosition = enemyUnitInfo.lastPosition;
									}
									else if (tempDistanceToAttack == minDistanceToAttack) {
										tempHitPointToAttack = enemyUnitInfo.lastHealth + enemyUnitInfo.lastShields;
										if (tempHitPointToAttack < minHitPointToAttack) {
											minHitPointToAttack = tempHitPointToAttack;

											targetEnemyUnit = enemyUnit;
											targetEnemyUnitPosition = enemyUnitInfo.lastPosition;
										}
									}
								}
							}
						}

						if (targetEnemyUnit != nullptr) {
							setUnitMission(unit, Mission(MissionType::MoveRoundAboutWay, targetEnemyUnit, targetEnemyUnitPosition));
							hasOrderedNewMission = true;
						}
					}
					else if (enemyWorkerUnitCount > 0) {

						if (targetEnemyUnit == nullptr) {

							//  ִָ  ϲ ϳ  
							int minDistanceToAttack = 0;
							int tempDistanceToAttack;
							int minHitPointToAttack = INT_MAX;
							int tempHitPointToAttack;

							for (auto & it : InformationManager::Instance().getUnitAndUnitInfoMap(InformationManager::Instance().enemyPlayer))
							{
								BWAPI::Unit enemyUnit = it.first;
								const UnitInfo & enemyUnitInfo = it.second;

								if (enemyUnitInfo.type == InformationManager::Instance().getWorkerType(InformationManager::Instance().enemyRace))
								{
									tempDistanceToAttack = unit->getDistance(enemyUnitInfo.lastPosition);
									if (tempDistanceToAttack > minDistanceToAttack) {
										minDistanceToAttack = tempDistanceToAttack;
										targetEnemyUnit = enemyUnit;
										targetEnemyUnitPosition = enemyUnitInfo.lastPosition;
									}
									else if (tempDistanceToAttack == minDistanceToAttack) {
										tempHitPointToAttack = enemyUnitInfo.lastHealth + enemyUnitInfo.lastShields;
										if (tempHitPointToAttack < minHitPointToAttack) {
											minHitPointToAttack = tempHitPointToAttack;
											targetEnemyUnit = enemyUnit;
											targetEnemyUnitPosition = enemyUnitInfo.lastPosition;
										}
									}
								}
							}
						}

						if (targetEnemyUnit != nullptr) {
							setUnitMission(unit, Mission(MissionType::MoveRoundAboutWay, targetEnemyUnit, targetEnemyUnitPosition));
							hasOrderedNewMission = true;
						}
					}
				}
				else if (selfMutaliskCount <= 4) {
					setUnitMission(unit, Mission(MissionType::Move, nullptr, InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().selfPlayer)->getPosition()));
				}
			}
		}
	}
	*/
}

void Strategy_CombatTaskManager::updateUnitMissionForOverlord()
{
	/*
	bool isToReassignUnitMission = false;
	BWAPI::Unit targetEnemyUnit = nullptr;
	BWAPI::Position targetEnemyUnitPosition = BWAPI::Positions::None;
	BWTA::BaseLocation * selfMainBaseLocation = InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().selfPlayer);

	for (auto & unit : BWAPI::Broodwar->self()->getUnits())
	{
	if (unit == nullptr || unit->exists() == false || unit->getHitPoints() == 0 || unit->isCompleted() == false) continue;

	if (unit->getType() == BWAPI::UnitTypes::Zerg_Overlord)
	{
	if (selfMainBaseLocation != nullptr)
	{
	if (unit->isIdle()) {
	setUnitMission(unit, Mission(MissionType::Move, nullptr, InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().selfPlayer)->getPosition()));
	}
	}
	}
	}
	*/
}

void Strategy_CombatTaskManager::updateUnitMissionForLurker()
{
	/*
	bool isToReassignUnitMission = false;
	BWAPI::Unit targetEnemyUnit = nullptr;
	BWAPI::Position targetEnemyUnitPosition = BWAPI::Positions::None;
	BWTA::BaseLocation * selfMainBaseLocation = InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().selfPlayer);

	for (auto & unit : BWAPI::Broodwar->self()->getUnits())
	{
	if (unit == nullptr || unit->exists() == false || unit->getHitPoints() == 0 || unit->isCompleted() == false) continue;

	if (unit->getType() == BWAPI::UnitTypes::Zerg_Lurker)
	{
	if (selfMainBaseLocation != nullptr)
	{
	if (unit->isIdle()) {

	if (unit->getDistance(InformationManager::Instance().getSecondChokePoint(InformationManager::Instance().selfPlayer)->getCenter()) > 8 * TILE_SIZE) {
	setUnitMission(unit, Mission(MissionType::Move, nullptr, InformationManager::Instance().getSecondChokePoint(InformationManager::Instance().selfPlayer)->getCenter()));
	}
	else {
	setUnitMission(unit, Mission(MissionType::Burrow, nullptr, InformationManager::Instance().getSecondChokePoint(InformationManager::Instance().selfPlayer)->getCenter()));
	}
	}
	}
	}
	}
	*/
}

void Strategy_CombatTaskManager::updateUnitMissionForQueen()
{
	/*
	bool isToReassignUnitMission = false;
	BWAPI::Unit targetEnemyUnit = nullptr;
	BWAPI::Position targetEnemyUnitPosition = BWAPI::Positions::None;
	BWTA::BaseLocation * enemyMainBaseLocation = InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().enemyPlayer);
	BWTA::BaseLocation * selfMainBaseLocation = InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().selfPlayer);

	// ׳ BWAPI::Broodwar->enemy()->getUnits()  ϸ,  ʰ   ȸ ȵǰ, 
	// getUnitAndUnitInfoMap ص enemyUnit   ʰԵǸ, getType()  Unknown  ȸȴ
	for (auto & it : InformationManager::Instance().getUnitAndUnitInfoMap(InformationManager::Instance().enemyPlayer))
	{
		BWAPI::Unit enemyUnit = it.first;
		UnitInfo & enemyUnitInfo = it.second;

		if (enemyUnitInfo.type.isBuilding() || enemyUnit->isParasited() == true || enemyUnitInfo.isAssignedAsParasiteTarget == true) {
			continue;
		}

		targetEnemyUnit = nullptr;
		targetEnemyUnitPosition = BWAPI::Positions::None;

		// TODO : Queen ӹ  Unit   -> ӹ   ϰų, maelstrome / stasis field ϰų ٸ Queen 

		// TODO :   Queen  ó


		// Parasite 
		if (enemyUnitInfo.type == BWAPI::UnitTypes::Terran_Science_Vessel
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Terran_Dropship
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Protoss_Observer
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Protoss_Shuttle
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Protoss_Carrier
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Zerg_Mutalisk)
		{
			// ̹ ٸ Queen  Parasite  ̸, skip Ѵ
			if (enemyUnitInfo.isAssignedAsParasiteTarget == false) {

				for (auto & unit : BWAPI::Broodwar->self()->getUnits())
				{
					if (unit == nullptr || unit->exists() == false || unit->getHitPoints() == 0 || unit->isCompleted() == false) continue;

					if (unit->getType() == BWAPI::UnitTypes::Zerg_Queen)
					{
						if (unit->isIdle()) {

							if (BWAPI::Broodwar->self()->hasResearched(BWAPI::TechTypes::Parasite)
								&& unit->getEnergy() >= BWAPI::TechTypes::Parasite.energyCost())
							{
								targetEnemyUnit = enemyUnit;
								targetEnemyUnitPosition = enemyUnitInfo.lastPosition;
								enemyUnitInfo.isAssignedAsParasiteTarget = true;
								setUnitMission(unit, Mission(MissionType::Parasite, targetEnemyUnit, targetEnemyUnitPosition));
								break;
							}
						}
					}
				}
			}
		}

		// Spawn_Broodlings 
		if (enemyUnitInfo.type == BWAPI::UnitTypes::Terran_Siege_Tank_Tank_Mode
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Terran_Siege_Tank_Siege_Mode
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Protoss_Reaver
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Protoss_High_Templar
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Protoss_Archon
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Protoss_Dark_Archon
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Zerg_Lurker
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Zerg_Ultralisk
			|| enemyUnitInfo.type == BWAPI::UnitTypes::Zerg_Defiler)
		{
			if (enemyUnitInfo.isAssignedAsSpawnBroodlingsTarget == false) {

				for (auto & unit : BWAPI::Broodwar->self()->getUnits())
				{
					if (unit == nullptr || unit->exists() == false || unit->getHitPoints() == 0 || unit->isCompleted() == false) continue;

					if (unit->getType() == BWAPI::UnitTypes::Zerg_Queen)
					{
						if (unit->isIdle()) {

							if (BWAPI::Broodwar->self()->hasResearched(BWAPI::TechTypes::Spawn_Broodlings)
								&& unit->getEnergy() >= BWAPI::TechTypes::Spawn_Broodlings.energyCost())
							{
								targetEnemyUnit = enemyUnit;
								targetEnemyUnitPosition = enemyUnitInfo.lastPosition;
								enemyUnitInfo.isAssignedAsSpawnBroodlingsTarget = true;
								setUnitMission(unit, Mission(MissionType::Spawn_Broodlings, targetEnemyUnit, targetEnemyUnitPosition));
								break;
							}
						}
					}
				}
			}
		}
	}
	*/
	// 

	// TODO : ӹϼ  üũ. ӹ  ڸ ̵?

	/*
	for (auto & unit : BWAPI::Broodwar->self()->getUnits())
	{
	if (unit == nullptr || unit->exists() == false || unit->getHitPoints() == 0 || unit->isCompleted() == false) continue;

	if (unit->getType() == BWAPI::UnitTypes::Zerg_Queen)
	{
	if (selfMainBaseLocation != nullptr)
	{
	if (unit->isIdle()) {
	setUnitMission(unit, Mission(MissionType::Move, nullptr, InformationManager::Instance().getMainBaseLocation(InformationManager::Instance().selfPlayer)->getPosition()));
	}
	}
	}
	}
	*/

}


void Strategy_CombatTaskManager::executeEnemyElimination()
{
	int enemyBuildingCount = 0;
	int enemyNonBuildingCount = 0;
	BWAPI::Position targetPosition = BWAPI::Positions::None;
	for (auto & enemyUnit : StrategyManager::Instance().enemyPlayer->getUnits()) {

		if (enemyUnit->getType().isBuilding()) {
			enemyBuildingCount++;
			targetPosition = enemyUnit->getPosition();
		}
		else {
			enemyNonBuildingCount++;
		}
	}

	Squad* currentSquad = nullptr;
	for (int i = 0; i < 12; i++) {
		if (i == 0) currentSquad = &StrategyManager::Instance().mainCombatZerglingSquad;
		else if (i == 1) currentSquad = &StrategyManager::Instance().mainCombatHydraliskSquad;
		else if (i == 2) currentSquad = &StrategyManager::Instance().mainCombatLurkerSquad;
		else if (i == 3) currentSquad = &StrategyManager::Instance().mainCombatMutaliskSquad;
		else if (i == 4) currentSquad = &StrategyManager::Instance().mainCombatScourgeSquad;
		else if (i == 5) currentSquad = &StrategyManager::Instance().mainCombatOverlordSquad;
		else if (i == 6) currentSquad = &StrategyManager::Instance().mainCombatQueenSquad;
		else if (i == 7) currentSquad = &StrategyManager::Instance().mainCombatUltraliskSquad;
		else if (i == 8) currentSquad = &StrategyManager::Instance().reinforceMainCombatMutaliskSquad;
		else if (i == 9) currentSquad = &StrategyManager::Instance().subCombatSquad;
		else if (i == 10) currentSquad = &StrategyManager::Instance().subCombatOverlordSquad;
		else if (i == 11) currentSquad = &StrategyManager::Instance().subCombatReinforceSquad;
		
		if (enemyBuildingCount > 0) {
			for (auto & unit : currentSquad->unitset) {
				currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, targetPosition));
			}
		}
		else 
		{		
			for (auto & unit : currentSquad->unitset) {
				Mission* unitMission = currentSquad->getUnitMission(unit);
				
				/*
				bool isStopped = false;
				UnitAndUnitInfoMap & unitAndUnitInfoMap = InformationManager::Instance().getUnitAndUnitInfoMap(StrategyManager::Instance().selfPlayer);
				if (unitAndUnitInfoMap.find(unit) != unitAndUnitInfoMap.end()) {
					auto it = unitAndUnitInfoMap.find(unit);
					UnitInfo & unitInfo = it->second;
					if (unitInfo.lastPosition == unitInfo.positionBefore
						&& unitInfo.lastPositionRecordFrame - unitInfo.positionBeforeRecordFrame >= 10) 
					{
						isStopped = true;
						std::cout << unit->getType().getName().c_str() << " is stopped at " << unitInfo.lastPosition.x / TILE_SIZE << "," << unitInfo.lastPosition.y / TILE_SIZE << std::endl;
					}
				}
				*/

				if (unitMission->targetPosition == BWAPI::Positions::None 
					//|| isStopped == true
					|| unit->isIdle()
					) 
				{
					targetPosition = BWAPI::Position(rand() % BWAPI::Broodwar->mapWidth() * TILE_SIZE, rand() % BWAPI::Broodwar->mapHeight() * TILE_SIZE);
					currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, targetPosition));
				}
				else {
					if (unit->getDistance(unitMission->targetPosition) < 3 * TILE_SIZE) {
						targetPosition = BWAPI::Position(rand() % BWAPI::Broodwar->mapWidth() * TILE_SIZE, rand() % BWAPI::Broodwar->mapHeight() * TILE_SIZE);
						currentSquad->setUnitMission(unit, Mission(MissionType::AttackMove, targetPosition));
					}
				}

			}
		}
	}
}


